<html>
<head>
<title>Stress Test Demo</title>

<script type="text/javascript">
//<![CDATA[

function NumNaclModulesReady(modules) {
  var count = 0;
  for (var i = 0; i < modules.length; i++) {
    if (modules[i].__moduleReady == 1) {
      count += 1;
    }
  }
  return count;
}


function AreTherePluginProblems(modules) {
  for (var i = 0; i < modules.length; i++) {
    if (modules[i].__moduleReady == undefined) return 1;
  }
  return 0;
}


var intervalHandler;
var retryCount = 50; // 50 * 100msec == 5 sec


function CheckModuleReadiness(modules) {
  var num_ready = NumNaclModulesReady(modules);

  // status update
  var status = document.getElementById("status");
  status.innerHTML = "" + retryCount + ": Loaded " +
                     num_ready + "/" + modules.length + " modules";

  if (modules.length == num_ready) {
    clearInterval(intervalHandler);
    return;
  }

  if (AreTherePluginProblems(modules)) {
    clearInterval(intervalHandler);
    alert('The Native Client plugin was unable to load');
    return;
  }

  if (retryCount == 0) {
    clearInterval(intervalHandler);
    alert('The Native Client modules are loading too slowly');
    return;
  }

  retryCount -= 1;
}


function OnLoadInit() {
  var modules = document.getElementsByName("nacl_module");
  // give focus to the first module, life, since it responds to mouse events
  modules[0].focus();

  intervalHandler = setInterval(CheckModuleReadiness, 100, modules);
}


function OnUnLoadExit() {
  clearInterval(intervalHandler);
}
//]]>
</script>

</head>
<body onload="OnLoadInit();" onunload="OnUnLoadExit();" >

<h1>Nine Native Client Demos, One Page</h1>
 <p>
  Life, Voronoi, and Earth as nine Native Client processes on one HTML page.
  Normally, you wouldn't want this many CPU-intensive NaCl processes running on
  a single web page.  This is primarily an artificial stress test.
 </p>
<embed name="nacl_module" src="life.nexe" type="application/x-nacl-srpc" width=256 height=256 />
<embed name="nacl_module" src="voronoi.nexe" type="application/x-nacl-srpc" width=256 height=256 />
<embed name="nacl_module" src="earth.nexe" type="application/x-nacl-srpc" width=256 height=256 />
<br>
<embed name="nacl_module" src="earth.nexe" type="application/x-nacl-srpc" width=256 height=256 />
<embed name="nacl_module" src="life.nexe" type="application/x-nacl-srpc" width=256 height=256 />
<embed name="nacl_module" src="voronoi.nexe" type="application/x-nacl-srpc" width=256 height=256 />
<br>
<embed name="nacl_module" src="voronoi.nexe" type="application/x-nacl-srpc" width=256 height=256 />
<embed name="nacl_module" src="earth.nexe" type="application/x-nacl-srpc" width=256 height=256 />
<embed name="nacl_module" src="life.nexe" type="application/x-nacl-srpc" width=256 height=256 />
<br>

<div id=status></div>

</body>
</html>
